Package org.flowable.cmmn.model

# Class PlanItem

java.lang.Object
org.flowable.cmmn.model.BaseElement
org.flowable.cmmn.model.CmmnElement
org.flowable.cmmn.model.CaseElement
org.flowable.cmmn.model.PlanItem

All Implemented Interfaces:
  `HasAssociations`, `HasEntryCriteria`, `HasExitCriteria`, `HasExtensionAttributes`

public class PlanItem extends CaseElement implements HasEntryCriteria, HasExitCriteria, HasAssociations

Author:
  Joram Barrez

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected Object`
  `behavior`
  `protected Set<String>`
  `criteriaRefs`
  `protected String`
  `definitionRef`
  `protected List<Criterion>`
  `entryCriteria`
  `protected List<PlanItem>`
  `entryDependencies`
  A list of `PlanItem`s to which this plan item is dependent on through its entry criteria.
  `protected List<PlanItem>`
  `entryDependentPlanItems`
  A list of all `PlanItem`s that are dependent on this plan item through their entry criteria.
  `protected List<Criterion>`
  `exitCriteria`
  `protected List<PlanItem>`
  `exitDependencies`
  A list of `PlanItem`s to which this plan item is dependent on through its exit criteria.
  `protected List<PlanItem>`
  `exitDependentPlanItems`
  A list of all `PlanItem`s that are dependent on this plan item through their exit criteria.
  `protected List<Association>`
  `incomingAssociations`
  `protected boolean`
  `instanceLifecycleEnabled`
  `protected PlanItemControl`
  `itemControl`
  `protected List<Association>`
  `outgoingAssociations`
  `protected PlanItemDefinition`
  `planItemDefinition`

  ### Fields inherited from class org.flowable.cmmn.model.CaseElement

  `name, parent`

  ### Fields inherited from class org.flowable.cmmn.model.CmmnElement

  `documentation, documentationTextFormat`

  ### Fields inherited from class org.flowable.cmmn.model.BaseElement

  `attributes, extensionElements, id, xmlColumnNumber, xmlRowNumber`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PlanItem()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addCriteriaRef(String entryCriteriaRef)`
  `void`
  `addEntryCriterion(Criterion entryCriterion)`
  `void`
  `addEntryDependentPlanItem(PlanItem planItem)`
  `void`
  `addExitCriterion(Criterion exitCriterion)`
  `void`
  `addExitDependentPlanItem(PlanItem planItem)`
  `void`
  `addIncomingAssociation(Association association)`
  `void`
  `addOutgoingAssociation(Association association)`
  `List<PlanItem>`
  `getAllDependentPlanItems()`
  `Object`
  `getBehavior()`
  `Set<String>`
  `getCriteriaRefs()`
  `String`
  `getDefinitionRef()`
  `List<Criterion>`
  `getEntryCriteria()`
  `List<PlanItem>`
  `getEntryDependencies()`
  `List<PlanItem>`
  `getEntryDependentPlanItems()`
  `List<Criterion>`
  `getExitCriteria()`
  `List<PlanItem>`
  `getExitDependencies()`
  `List<PlanItem>`
  `getExitDependentPlanItems()`
  `List<Association>`
  `getIncomingAssociations()`
  `PlanItemControl`
  `getItemControl()`
  `List<Association>`
  `getOutgoingAssociations()`
  `PlanItemDefinition`
  `getPlanItemDefinition()`
  `boolean`
  `isInstanceLifecycleEnabled()`
  `void`
  `setBehavior(Object behavior)`
  `void`
  `setCriteriaRefs(Set<String> criteriaRefs)`
  `void`
  `setDefinitionRef(String definitionRef)`
  `void`
  `setEntryCriteria(List<Criterion> entryCriteria)`
  `void`
  `setEntryDependencies(List<PlanItem> entryDependencies)`
  `void`
  `setEntryDependentPlanItems(List<PlanItem> entryDependentPlanItems)`
  `void`
  `setExitCriteria(List<Criterion> exitCriteria)`
  `void`
  `setExitDependencies(List<PlanItem> exitDependencies)`
  `void`
  `setExitDependentPlanItems(List<PlanItem> exitDependentPlanItems)`
  `void`
  `setIncomingAssociations(List<Association> incomingAssociations)`
  `void`
  `setInstanceLifecycleEnabled(boolean instanceLifecycleEnabled)`
  `void`
  `setItemControl(PlanItemControl itemControl)`
  `void`
  `setOutgoingAssociations(List<Association> outgoingAssociations)`
  `void`
  `setPlanItemDefinition(PlanItemDefinition planItemDefinition)`
  `String`
  `toString()`

  ### Methods inherited from class org.flowable.cmmn.model.CaseElement

  `getName, getParent, getParentStage, setName, setParent`

  ### Methods inherited from class org.flowable.cmmn.model.CmmnElement

  `getDocumentation, getDocumentationTextFormat, setDocumentation, setDocumentationTextFormat, setValues`

  ### Methods inherited from class org.flowable.cmmn.model.BaseElement

  `addAttribute, addExtensionElement, getAttributes, getAttributeValue, getExtensionElements, getId, getXmlColumnNumber, getXmlRowNumber, setAttributes, setExtensionElements, setId, setValues, setXmlColumnNumber, setXmlRowNumber`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.flowable.cmmn.model.HasEntryCriteria

  `getId`

  ### Methods inherited from interface org.flowable.cmmn.model.HasExitCriteria

  `getId`

- ## Field Details

  - ### definitionRef

    protected String definitionRef

  - ### planItemDefinition

    protected PlanItemDefinition planItemDefinition

  - ### instanceLifecycleEnabled

    protected boolean instanceLifecycleEnabled

  - ### itemControl

    protected PlanItemControl itemControl

  - ### criteriaRefs

    protected Set<String> criteriaRefs

  - ### entryCriteria

    protected List<Criterion> entryCriteria

  - ### exitCriteria

    protected List<Criterion> exitCriteria

  - ### incomingAssociations

    protected List<Association> incomingAssociations

  - ### outgoingAssociations

    protected List<Association> outgoingAssociations

  - ### entryDependencies

    protected List<PlanItem> entryDependencies
    A list of `PlanItem`s to which this plan item is dependent on through its entry criteria. Said differently: this list of plan items will influence entry criteria on this plan item.

  - ### exitDependencies

    protected List<PlanItem> exitDependencies
    A list of `PlanItem`s to which this plan item is dependent on through its exit criteria. Said differently: this list of plan items will influence exit criteria on this plan item.

  - ### entryDependentPlanItems

    protected List<PlanItem> entryDependentPlanItems
    A list of all `PlanItem`s that are dependent on this plan item through their entry criteria. Said differently: this list of plan items have an entry criteria that references this plan item.

  - ### exitDependentPlanItems

    protected List<PlanItem> exitDependentPlanItems
    A list of all `PlanItem`s that are dependent on this plan item through their exit criteria. Said differently: this list of plan items have an exit criteria that references this plan item.

  - ### behavior

    protected Object behavior

- ## Constructor Details

  - ### PlanItem

    public PlanItem()

- ## Method Details

  - ### getDefinitionRef

    public String getDefinitionRef()

  - ### setDefinitionRef

    public void setDefinitionRef(String definitionRef)

  - ### getPlanItemDefinition

    public PlanItemDefinition getPlanItemDefinition()

  - ### setPlanItemDefinition

    public void setPlanItemDefinition(PlanItemDefinition planItemDefinition)

  - ### isInstanceLifecycleEnabled

    public boolean isInstanceLifecycleEnabled()

  - ### setInstanceLifecycleEnabled

    public void setInstanceLifecycleEnabled(boolean instanceLifecycleEnabled)

  - ### getItemControl

    public PlanItemControl getItemControl()

  - ### setItemControl

    public void setItemControl(PlanItemControl itemControl)

  - ### addCriteriaRef

    public void addCriteriaRef(String entryCriteriaRef)

  - ### getCriteriaRefs

    public Set<String> getCriteriaRefs()

  - ### setCriteriaRefs

    public void setCriteriaRefs(Set<String> criteriaRefs)

  - ### addEntryCriterion

    public void addEntryCriterion(Criterion entryCriterion)
    Specified by:
      `addEntryCriterion` in interface `HasEntryCriteria`

  - ### getEntryCriteria

    public List<Criterion> getEntryCriteria()
    Specified by:
      `getEntryCriteria` in interface `HasEntryCriteria`

  - ### setEntryCriteria

    public void setEntryCriteria(List<Criterion> entryCriteria)
    Specified by:
      `setEntryCriteria` in interface `HasEntryCriteria`

  - ### addExitCriterion

    public void addExitCriterion(Criterion exitCriterion)
    Specified by:
      `addExitCriterion` in interface `HasExitCriteria`

  - ### getExitCriteria

    public List<Criterion> getExitCriteria()
    Specified by:
      `getExitCriteria` in interface `HasExitCriteria`

  - ### setExitCriteria

    public void setExitCriteria(List<Criterion> exitCriteria)
    Specified by:
      `setExitCriteria` in interface `HasExitCriteria`

  - ### addIncomingAssociation

    public void addIncomingAssociation(Association association)
    Specified by:
      `addIncomingAssociation` in interface `HasAssociations`

  - ### getIncomingAssociations

    public List<Association> getIncomingAssociations()
    Specified by:
      `getIncomingAssociations` in interface `HasAssociations`

  - ### setIncomingAssociations

    public void setIncomingAssociations(List<Association> incomingAssociations)
    Specified by:
      `setIncomingAssociations` in interface `HasAssociations`

  - ### addOutgoingAssociation

    public void addOutgoingAssociation(Association association)
    Specified by:
      `addOutgoingAssociation` in interface `HasAssociations`

  - ### getOutgoingAssociations

    public List<Association> getOutgoingAssociations()
    Specified by:
      `getOutgoingAssociations` in interface `HasAssociations`

  - ### setOutgoingAssociations

    public void setOutgoingAssociations(List<Association> outgoingAssociations)
    Specified by:
      `setOutgoingAssociations` in interface `HasAssociations`

  - ### getBehavior

    public Object getBehavior()

  - ### setBehavior

    public void setBehavior(Object behavior)

  - ### getEntryDependencies

    public List<PlanItem> getEntryDependencies()

  - ### setEntryDependencies

    public void setEntryDependencies(List<PlanItem> entryDependencies)

  - ### getExitDependencies

    public List<PlanItem> getExitDependencies()

  - ### setExitDependencies

    public void setExitDependencies(List<PlanItem> exitDependencies)

  - ### getEntryDependentPlanItems

    public List<PlanItem> getEntryDependentPlanItems()

  - ### setEntryDependentPlanItems

    public void setEntryDependentPlanItems(List<PlanItem> entryDependentPlanItems)

  - ### addEntryDependentPlanItem

    public void addEntryDependentPlanItem(PlanItem planItem)

  - ### getExitDependentPlanItems

    public List<PlanItem> getExitDependentPlanItems()

  - ### setExitDependentPlanItems

    public void setExitDependentPlanItems(List<PlanItem> exitDependentPlanItems)

  - ### addExitDependentPlanItem

    public void addExitDependentPlanItem(PlanItem planItem)

  - ### getAllDependentPlanItems

    public List<PlanItem> getAllDependentPlanItems()

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`